/* PolkitDialog.c generated by valac 0.56.17, the Vala compiler
 * generated from PolkitDialog.vala, do not modify */

/*-
 * Copyright (c) 2015-2019 elementary, Inc. (https://elementary.io)
 * Copyright (C) 2015-2016 Ikey Doherty <ikey@solus-project.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Adam Bieńkowski <donadigos159@gmail.com>
 */
/*
 * Code based on budgie-desktop:
 * https://github.com/solus-project/budgie-desktop
 */

#include <granite-7.h>
#include <glib-object.h>
#include <glib.h>
#include <polkitagent/polkitagent.h>
#include <polkit/polkit.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <pwd.h>
#include <sys/types.h>
#include <grp.h>
#include <adwaita.h>
#include <gsk/gsk.h>
#include <graphene-gobject.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define AG_TYPE_POLKIT_DIALOG (ag_polkit_dialog_get_type ())
#define AG_POLKIT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), AG_TYPE_POLKIT_DIALOG, AgPolkitDialog))
#define AG_POLKIT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), AG_TYPE_POLKIT_DIALOG, AgPolkitDialogClass))
#define AG_IS_POLKIT_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), AG_TYPE_POLKIT_DIALOG))
#define AG_IS_POLKIT_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), AG_TYPE_POLKIT_DIALOG))
#define AG_POLKIT_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), AG_TYPE_POLKIT_DIALOG, AgPolkitDialogClass))

typedef struct _AgPolkitDialog AgPolkitDialog;
typedef struct _AgPolkitDialogClass AgPolkitDialogClass;
typedef struct _AgPolkitDialogPrivate AgPolkitDialogPrivate;
enum  {
	AG_POLKIT_DIALOG_0_PROPERTY,
	AG_POLKIT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* ag_polkit_dialog_properties[AG_POLKIT_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block3Data Block3Data;
enum  {
	AG_POLKIT_DIALOG_DONE_SIGNAL,
	AG_POLKIT_DIALOG_NUM_SIGNALS
};
static guint ag_polkit_dialog_signals[AG_POLKIT_DIALOG_NUM_SIGNALS] = {0};

struct _AgPolkitDialog {
	GraniteMessageDialog parent_instance;
	AgPolkitDialogPrivate * priv;
	gboolean was_canceled;
};

struct _AgPolkitDialogClass {
	GraniteMessageDialogClass parent_class;
};

struct _AgPolkitDialogPrivate {
	PolkitAgentSession* pk_session;
	PolkitIdentity* pk_identity;
	GCancellable* cancellable;
	gulong error_signal_id;
	gulong request_signal_id;
	gulong info_signal_id;
	gulong complete_signal_id;
	GList* idents;
	gchar* cookie;
	gboolean canceling;
	GtkRevealer* feedback_revealer;
	GtkLabel* password_label;
	GtkLabel* password_feedback;
	GtkEntry* password_entry;
	GtkComboBox* idents_combo;
};

struct _Block3Data {
	int _ref_count_;
	AgPolkitDialog* self;
	gint width;
	gint height;
	AdwTimedAnimation* shake;
	gint repeat_count;
	gulong iterate;
	gchar* text;
};

static gint AgPolkitDialog_private_offset;
static gpointer ag_polkit_dialog_parent_class = NULL;

VALA_EXTERN GType ag_polkit_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AgPolkitDialog, g_object_unref)
VALA_EXTERN AgPolkitDialog* ag_polkit_dialog_new (const gchar* message,
                                      const gchar* icon_name,
                                      const gchar* _cookie,
                                      GList* _idents,
                                      GCancellable* _cancellable);
VALA_EXTERN AgPolkitDialog* ag_polkit_dialog_construct (GType object_type,
                                            const gchar* message,
                                            const gchar* icon_name,
                                            const gchar* _cookie,
                                            GList* _idents,
                                            GCancellable* _cancellable);
static void ag_polkit_dialog_cancel (AgPolkitDialog* self);
static void _ag_polkit_dialog_cancel_g_cancellable_cancelled (GCancellable* _sender,
                                                       gpointer self);
static void ag_polkit_dialog_on_ident_changed (AgPolkitDialog* self);
static void _ag_polkit_dialog_on_ident_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                               gpointer self);
static void __lambda7_ (AgPolkitDialog* self);
static void ___lambda7__gtk_button_clicked (GtkButton* _sender,
                                     gpointer self);
static void ag_polkit_dialog_authenticate (AgPolkitDialog* self);
static void _ag_polkit_dialog_authenticate_gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _ag_polkit_dialog_cancel_gtk_dialog_close (GtkDialog* _sender,
                                                gpointer self);
static void ag_polkit_dialog_update_idents (AgPolkitDialog* self);
static void ag_polkit_dialog_select_session (AgPolkitDialog* self);
static void ag_polkit_dialog_deselect_session (AgPolkitDialog* self);
static void ag_polkit_dialog_on_pk_show_error (AgPolkitDialog* self,
                                        const gchar* text);
static void _ag_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error (PolkitAgentSession* _sender,
                                                                         const gchar* text,
                                                                         gpointer self);
static void ag_polkit_dialog_on_pk_session_completed (AgPolkitDialog* self,
                                               gboolean authorized);
static void _ag_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed (PolkitAgentSession* _sender,
                                                                               gboolean gained_authorization,
                                                                               gpointer self);
static void ag_polkit_dialog_on_pk_request (AgPolkitDialog* self,
                                     const gchar* request,
                                     gboolean echo_on);
static void _ag_polkit_dialog_on_pk_request_polkit_agent_session_request (PolkitAgentSession* _sender,
                                                                   const gchar* request,
                                                                   gboolean echo_on,
                                                                   gpointer self);
static void ag_polkit_dialog_on_pk_show_info (AgPolkitDialog* self,
                                       const gchar* text);
static void _ag_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info (PolkitAgentSession* _sender,
                                                                       const gchar* text,
                                                                       gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda5_ (Block3Data* _data3_,
                 gdouble val);
static void ___lambda5__adw_animation_target_func (gdouble value,
                                            gpointer self);
static void __lambda6_ (Block3Data* _data3_);
static void ___lambda6__adw_animation_done (AdwAnimation* _sender,
                                     gpointer self);
static void ag_polkit_dialog_finalize (GObject * obj);
static GType ag_polkit_dialog_get_type_once (void);

static inline gpointer
ag_polkit_dialog_get_instance_private (AgPolkitDialog* self)
{
	return G_STRUCT_MEMBER_P (self, AgPolkitDialog_private_offset);
}

static void
_ag_polkit_dialog_cancel_g_cancellable_cancelled (GCancellable* _sender,
                                                  gpointer self)
{
#line 58 "../src/PolkitDialog.vala"
	ag_polkit_dialog_cancel ((AgPolkitDialog*) self);
#line 209 "PolkitDialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 79 "../src/PolkitDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 217 "PolkitDialog.c"
}

static void
_ag_polkit_dialog_on_ident_changed_gtk_combo_box_changed (GtkComboBox* _sender,
                                                          gpointer self)
{
#line 86 "../src/PolkitDialog.vala"
	ag_polkit_dialog_on_ident_changed ((AgPolkitDialog*) self);
#line 226 "PolkitDialog.c"
}

static void
__lambda7_ (AgPolkitDialog* self)
{
#line 112 "../src/PolkitDialog.vala"
	ag_polkit_dialog_cancel (self);
#line 234 "PolkitDialog.c"
}

static void
___lambda7__gtk_button_clicked (GtkButton* _sender,
                                gpointer self)
{
#line 112 "../src/PolkitDialog.vala"
	__lambda7_ ((AgPolkitDialog*) self);
#line 243 "PolkitDialog.c"
}

static void
_ag_polkit_dialog_authenticate_gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 117 "../src/PolkitDialog.vala"
	ag_polkit_dialog_authenticate ((AgPolkitDialog*) self);
#line 252 "PolkitDialog.c"
}

static void
_ag_polkit_dialog_cancel_gtk_dialog_close (GtkDialog* _sender,
                                           gpointer self)
{
#line 122 "../src/PolkitDialog.vala"
	ag_polkit_dialog_cancel ((AgPolkitDialog*) self);
#line 261 "PolkitDialog.c"
}

AgPolkitDialog*
ag_polkit_dialog_construct (GType object_type,
                            const gchar* message,
                            const gchar* icon_name,
                            const gchar* _cookie,
                            GList* _idents,
                            GCancellable* _cancellable)
{
	AgPolkitDialog * self = NULL;
	gchar* _tmp0_;
	GCancellable* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkEntry* _tmp4_ = NULL;
	GtkLabel* _tmp5_ = NULL;
	GtkLabel* _tmp6_;
	GtkLabel* _tmp7_;
	GtkWidget* _tmp8_;
	GtkRevealer* _tmp9_ = NULL;
	GtkComboBox* _tmp10_ = NULL;
	GtkComboBox* _tmp11_;
	GtkCellRenderer* renderer = NULL;
	GtkCellRendererPixbuf* _tmp12_;
	GtkComboBox* _tmp13_;
	GtkCellRenderer* _tmp14_;
	GtkComboBox* _tmp15_;
	GtkCellRenderer* _tmp16_;
	GtkCellRendererText* _tmp17_;
	GtkCellRenderer* _tmp18_;
	GtkComboBox* _tmp19_;
	GtkCellRenderer* _tmp20_;
	GtkComboBox* _tmp21_;
	GtkCellRenderer* _tmp22_;
	GtkComboBox* _tmp23_;
	GtkBox* credentials_box = NULL;
	GtkBox* _tmp24_;
	GtkBox* _tmp25_;
	GtkComboBox* _tmp26_;
	GtkBox* _tmp27_;
	GtkEntry* _tmp28_;
	GtkBox* _tmp29_;
	GtkRevealer* _tmp30_;
	GThemedIcon* _tmp31_;
	GThemedIcon* _tmp32_;
	gboolean _tmp33_ = FALSE;
	GtkBox* _tmp38_;
	GtkBox* _tmp39_;
	GtkBox* _tmp40_;
	GtkButton* cancel_button = NULL;
	GtkWidget* _tmp41_;
	GtkButton* _tmp42_;
	GtkButton* authenticate_button = NULL;
	GtkWidget* _tmp43_;
	GtkButton* _tmp44_;
	GtkEntry* _tmp45_;
#line 49 "../src/PolkitDialog.vala"
	g_return_val_if_fail (message != NULL, NULL);
#line 49 "../src/PolkitDialog.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 49 "../src/PolkitDialog.vala"
	g_return_val_if_fail (_cookie != NULL, NULL);
#line 49 "../src/PolkitDialog.vala"
	g_return_val_if_fail (_cancellable != NULL, NULL);
#line 51 "../src/PolkitDialog.vala"
	self = (AgPolkitDialog*) g_object_new (object_type, "title", _ ("Authentication Dialog"), NULL);
#line 55 "../src/PolkitDialog.vala"
	self->priv->idents = _idents;
#line 56 "../src/PolkitDialog.vala"
	_tmp0_ = g_strdup (_cookie);
#line 56 "../src/PolkitDialog.vala"
	_g_free0 (self->priv->cookie);
#line 56 "../src/PolkitDialog.vala"
	self->priv->cookie = _tmp0_;
#line 57 "../src/PolkitDialog.vala"
	self->priv->cancellable = _cancellable;
#line 58 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->cancellable;
#line 58 "../src/PolkitDialog.vala"
	g_signal_connect_object (_tmp1_, "cancelled", (GCallback) _ag_polkit_dialog_cancel_g_cancellable_cancelled, self, 0);
#line 60 "../src/PolkitDialog.vala"
	granite_message_dialog_set_primary_text ((GraniteMessageDialog*) self, _ ("Authentication Required"));
#line 61 "../src/PolkitDialog.vala"
	granite_message_dialog_set_secondary_text ((GraniteMessageDialog*) self, message);
#line 63 "../src/PolkitDialog.vala"
	_tmp2_ = g_strdup ("dialog-password-symbolic");
#line 63 "../src/PolkitDialog.vala"
	_tmp3_ = g_strdup (_ ("Password"));
#line 63 "../src/PolkitDialog.vala"
	_tmp4_ = (GtkEntry*) gtk_entry_new ();
#line 63 "../src/PolkitDialog.vala"
	gtk_entry_set_activates_default (_tmp4_, TRUE);
#line 63 "../src/PolkitDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp4_, TRUE);
#line 63 "../src/PolkitDialog.vala"
	gtk_entry_set_input_purpose (_tmp4_, GTK_INPUT_PURPOSE_PASSWORD);
#line 63 "../src/PolkitDialog.vala"
	g_object_set (_tmp4_, "primary-icon-name", _tmp2_, NULL);
#line 63 "../src/PolkitDialog.vala"
	_g_free0 (_tmp2_);
#line 63 "../src/PolkitDialog.vala"
	g_object_set (_tmp4_, "primary-icon-tooltip-text", _tmp3_, NULL);
#line 63 "../src/PolkitDialog.vala"
	_g_free0 (_tmp3_);
#line 63 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp4_);
#line 63 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 63 "../src/PolkitDialog.vala"
	self->priv->password_entry = _tmp4_;
#line 71 "../src/PolkitDialog.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new (NULL);
#line 71 "../src/PolkitDialog.vala"
	gtk_label_set_justify (_tmp5_, GTK_JUSTIFY_RIGHT);
#line 71 "../src/PolkitDialog.vala"
	gtk_label_set_max_width_chars (_tmp5_, 40);
#line 71 "../src/PolkitDialog.vala"
	gtk_label_set_wrap (_tmp5_, TRUE);
#line 71 "../src/PolkitDialog.vala"
	gtk_label_set_xalign (_tmp5_, (gfloat) 1);
#line 71 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp5_);
#line 71 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_feedback);
#line 71 "../src/PolkitDialog.vala"
	self->priv->password_feedback = _tmp5_;
#line 77 "../src/PolkitDialog.vala"
	_tmp6_ = self->priv->password_feedback;
#line 77 "../src/PolkitDialog.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp6_, GRANITE_STYLE_CLASS_ERROR);
#line 79 "../src/PolkitDialog.vala"
	_tmp7_ = self->priv->password_feedback;
#line 79 "../src/PolkitDialog.vala"
	_tmp8_ = _g_object_ref0 ((GtkWidget*) _tmp7_);
#line 79 "../src/PolkitDialog.vala"
	_tmp9_ = (GtkRevealer*) gtk_revealer_new ();
#line 79 "../src/PolkitDialog.vala"
	gtk_revealer_set_child (_tmp9_, _tmp8_);
#line 79 "../src/PolkitDialog.vala"
	_g_object_unref0 (_tmp8_);
#line 79 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp9_);
#line 79 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->feedback_revealer);
#line 79 "../src/PolkitDialog.vala"
	self->priv->feedback_revealer = _tmp9_;
#line 83 "../src/PolkitDialog.vala"
	_tmp10_ = (GtkComboBox*) gtk_combo_box_new ();
#line 83 "../src/PolkitDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp10_, TRUE);
#line 83 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp10_);
#line 83 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->idents_combo);
#line 83 "../src/PolkitDialog.vala"
	self->priv->idents_combo = _tmp10_;
#line 86 "../src/PolkitDialog.vala"
	_tmp11_ = self->priv->idents_combo;
#line 86 "../src/PolkitDialog.vala"
	g_signal_connect_object (_tmp11_, "changed", (GCallback) _ag_polkit_dialog_on_ident_changed_gtk_combo_box_changed, self, 0);
#line 88 "../src/PolkitDialog.vala"
	_tmp12_ = (GtkCellRendererPixbuf*) gtk_cell_renderer_pixbuf_new ();
#line 88 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp12_);
#line 88 "../src/PolkitDialog.vala"
	renderer = (GtkCellRenderer*) _tmp12_;
#line 89 "../src/PolkitDialog.vala"
	_tmp13_ = self->priv->idents_combo;
#line 89 "../src/PolkitDialog.vala"
	_tmp14_ = renderer;
#line 89 "../src/PolkitDialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp13_, _tmp14_, FALSE);
#line 90 "../src/PolkitDialog.vala"
	_tmp15_ = self->priv->idents_combo;
#line 90 "../src/PolkitDialog.vala"
	_tmp16_ = renderer;
#line 90 "../src/PolkitDialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp15_, _tmp16_, "icon-name", 0);
#line 92 "../src/PolkitDialog.vala"
	_tmp17_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
#line 92 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp17_);
#line 92 "../src/PolkitDialog.vala"
	_g_object_unref0 (renderer);
#line 92 "../src/PolkitDialog.vala"
	renderer = (GtkCellRenderer*) _tmp17_;
#line 93 "../src/PolkitDialog.vala"
	_tmp18_ = renderer;
#line 93 "../src/PolkitDialog.vala"
	g_object_set (_tmp18_, "xpad", (guint) 6, NULL);
#line 94 "../src/PolkitDialog.vala"
	_tmp19_ = self->priv->idents_combo;
#line 94 "../src/PolkitDialog.vala"
	_tmp20_ = renderer;
#line 94 "../src/PolkitDialog.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp19_, _tmp20_, TRUE);
#line 95 "../src/PolkitDialog.vala"
	_tmp21_ = self->priv->idents_combo;
#line 95 "../src/PolkitDialog.vala"
	_tmp22_ = renderer;
#line 95 "../src/PolkitDialog.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp21_, _tmp22_, "text", 1);
#line 96 "../src/PolkitDialog.vala"
	_tmp23_ = self->priv->idents_combo;
#line 96 "../src/PolkitDialog.vala"
	gtk_combo_box_set_id_column (_tmp23_, 1);
#line 98 "../src/PolkitDialog.vala"
	_tmp24_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 98 "../src/PolkitDialog.vala"
	g_object_ref_sink (_tmp24_);
#line 98 "../src/PolkitDialog.vala"
	credentials_box = _tmp24_;
#line 99 "../src/PolkitDialog.vala"
	_tmp25_ = credentials_box;
#line 99 "../src/PolkitDialog.vala"
	_tmp26_ = self->priv->idents_combo;
#line 99 "../src/PolkitDialog.vala"
	gtk_box_append (_tmp25_, (GtkWidget*) _tmp26_);
#line 100 "../src/PolkitDialog.vala"
	_tmp27_ = credentials_box;
#line 100 "../src/PolkitDialog.vala"
	_tmp28_ = self->priv->password_entry;
#line 100 "../src/PolkitDialog.vala"
	gtk_box_append (_tmp27_, (GtkWidget*) _tmp28_);
#line 101 "../src/PolkitDialog.vala"
	_tmp29_ = credentials_box;
#line 101 "../src/PolkitDialog.vala"
	_tmp30_ = self->priv->feedback_revealer;
#line 101 "../src/PolkitDialog.vala"
	gtk_box_append (_tmp29_, (GtkWidget*) _tmp30_);
#line 103 "../src/PolkitDialog.vala"
	_tmp31_ = (GThemedIcon*) g_themed_icon_new ("dialog-password");
#line 103 "../src/PolkitDialog.vala"
	_tmp32_ = _tmp31_;
#line 103 "../src/PolkitDialog.vala"
	granite_message_dialog_set_image_icon ((GraniteMessageDialog*) self, (GIcon*) _tmp32_);
#line 103 "../src/PolkitDialog.vala"
	_g_object_unref0 (_tmp32_);
#line 105 "../src/PolkitDialog.vala"
	if (g_strcmp0 (icon_name, "") != 0) {
#line 503 "PolkitDialog.c"
		GdkDisplay* _tmp34_;
		GtkIconTheme* _tmp35_;
#line 105 "../src/PolkitDialog.vala"
		_tmp34_ = gdk_display_get_default ();
#line 105 "../src/PolkitDialog.vala"
		_tmp35_ = gtk_icon_theme_get_for_display (_tmp34_);
#line 105 "../src/PolkitDialog.vala"
		_tmp33_ = gtk_icon_theme_has_icon (_tmp35_, icon_name);
#line 512 "PolkitDialog.c"
	} else {
#line 105 "../src/PolkitDialog.vala"
		_tmp33_ = FALSE;
#line 516 "PolkitDialog.c"
	}
#line 105 "../src/PolkitDialog.vala"
	if (_tmp33_) {
#line 520 "PolkitDialog.c"
		GThemedIcon* _tmp36_;
		GThemedIcon* _tmp37_;
#line 106 "../src/PolkitDialog.vala"
		_tmp36_ = (GThemedIcon*) g_themed_icon_new (icon_name);
#line 106 "../src/PolkitDialog.vala"
		_tmp37_ = _tmp36_;
#line 106 "../src/PolkitDialog.vala"
		granite_message_dialog_set_badge_icon ((GraniteMessageDialog*) self, (GIcon*) _tmp37_);
#line 106 "../src/PolkitDialog.vala"
		_g_object_unref0 (_tmp37_);
#line 531 "PolkitDialog.c"
	}
#line 109 "../src/PolkitDialog.vala"
	_tmp38_ = granite_message_dialog_get_custom_bin ((GraniteMessageDialog*) self);
#line 109 "../src/PolkitDialog.vala"
	_tmp39_ = _tmp38_;
#line 109 "../src/PolkitDialog.vala"
	_tmp40_ = credentials_box;
#line 109 "../src/PolkitDialog.vala"
	gtk_box_append (_tmp39_, (GtkWidget*) _tmp40_);
#line 111 "../src/PolkitDialog.vala"
	_tmp41_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 111 "../src/PolkitDialog.vala"
	_tmp42_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, gtk_button_get_type (), GtkButton));
#line 111 "../src/PolkitDialog.vala"
	cancel_button = _tmp42_;
#line 112 "../src/PolkitDialog.vala"
	g_signal_connect_object (cancel_button, "clicked", (GCallback) ___lambda7__gtk_button_clicked, self, 0);
#line 114 "../src/PolkitDialog.vala"
	_tmp43_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Authenticate"), (gint) GTK_RESPONSE_APPLY);
#line 114 "../src/PolkitDialog.vala"
	_tmp44_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, gtk_button_get_type (), GtkButton));
#line 114 "../src/PolkitDialog.vala"
	authenticate_button = _tmp44_;
#line 115 "../src/PolkitDialog.vala"
	gtk_widget_set_receives_default ((GtkWidget*) authenticate_button, TRUE);
#line 116 "../src/PolkitDialog.vala"
	gtk_widget_add_css_class ((GtkWidget*) authenticate_button, GRANITE_STYLE_CLASS_SUGGESTED_ACTION);
#line 117 "../src/PolkitDialog.vala"
	g_signal_connect_object (authenticate_button, "clicked", (GCallback) _ag_polkit_dialog_authenticate_gtk_button_clicked, self, 0);
#line 119 "../src/PolkitDialog.vala"
	gtk_window_set_default_widget ((GtkWindow*) self, (GtkWidget*) authenticate_button);
#line 120 "../src/PolkitDialog.vala"
	_tmp45_ = self->priv->password_entry;
#line 120 "../src/PolkitDialog.vala"
	g_object_set ((GtkWindow*) self, "focus-widget", (GtkWidget*) _tmp45_, NULL);
#line 122 "../src/PolkitDialog.vala"
	g_signal_connect_object ((GtkDialog*) self, "close", (GCallback) _ag_polkit_dialog_cancel_gtk_dialog_close, self, 0);
#line 124 "../src/PolkitDialog.vala"
	ag_polkit_dialog_update_idents (self);
#line 125 "../src/PolkitDialog.vala"
	ag_polkit_dialog_select_session (self);
#line 49 "../src/PolkitDialog.vala"
	_g_object_unref0 (authenticate_button);
#line 49 "../src/PolkitDialog.vala"
	_g_object_unref0 (cancel_button);
#line 49 "../src/PolkitDialog.vala"
	_g_object_unref0 (credentials_box);
#line 49 "../src/PolkitDialog.vala"
	_g_object_unref0 (renderer);
#line 49 "../src/PolkitDialog.vala"
	return self;
#line 583 "PolkitDialog.c"
}

AgPolkitDialog*
ag_polkit_dialog_new (const gchar* message,
                      const gchar* icon_name,
                      const gchar* _cookie,
                      GList* _idents,
                      GCancellable* _cancellable)
{
#line 49 "../src/PolkitDialog.vala"
	return ag_polkit_dialog_construct (AG_TYPE_POLKIT_DIALOG, message, icon_name, _cookie, _idents, _cancellable);
#line 595 "PolkitDialog.c"
}

static void
ag_polkit_dialog_update_idents (AgPolkitDialog* self)
{
	GtkListStore* model = NULL;
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
	gint length = 0;
	gint active = 0;
	gchar* target_user = NULL;
	GList* _tmp1_;
	GtkComboBox* _tmp34_;
	GtkListStore* _tmp35_;
	GtkComboBox* _tmp36_;
#line 128 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 129 "../src/PolkitDialog.vala"
	_tmp0_ = gtk_list_store_new (3, G_TYPE_STRING, G_TYPE_STRING, polkit_identity_get_type (), -1);
#line 129 "../src/PolkitDialog.vala"
	model = _tmp0_;
#line 132 "../src/PolkitDialog.vala"
	length = 0;
#line 133 "../src/PolkitDialog.vala"
	active = 0;
#line 135 "../src/PolkitDialog.vala"
	target_user = NULL;
#line 137 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->idents;
#line 625 "PolkitDialog.c"
	{
		GList* ident_collection = NULL;
		GList* ident_it = NULL;
#line 137 "../src/PolkitDialog.vala"
		ident_collection = _tmp1_;
#line 137 "../src/PolkitDialog.vala"
		for (ident_it = ident_collection; ident_it != NULL; ident_it = ident_it->next) {
#line 633 "PolkitDialog.c"
			PolkitIdentity* ident = NULL;
#line 137 "../src/PolkitDialog.vala"
			ident = (PolkitIdentity*) ident_it->data;
#line 637 "PolkitDialog.c"
			{
				PolkitIdentity* _tmp2_;
				gchar* name = NULL;
				PolkitIdentity* _tmp3_;
				gchar* _tmp4_;
				PolkitIdentity* _tmp5_;
				GtkListStore* _tmp25_;
				GtkTreeIter _tmp26_ = {0};
				GtkListStore* _tmp27_;
				GtkTreeIter _tmp28_;
				const gchar* _tmp29_;
				PolkitIdentity* _tmp30_;
				const gchar* _tmp31_;
				const gchar* _tmp32_;
				gint _tmp33_;
#line 138 "../src/PolkitDialog.vala"
				_tmp2_ = ident;
#line 138 "../src/PolkitDialog.vala"
				if (_tmp2_ == NULL) {
#line 139 "../src/PolkitDialog.vala"
					continue;
#line 659 "PolkitDialog.c"
				}
#line 142 "../src/PolkitDialog.vala"
				_tmp3_ = ident;
#line 142 "../src/PolkitDialog.vala"
				_tmp4_ = polkit_identity_to_string (_tmp3_);
#line 142 "../src/PolkitDialog.vala"
				name = _tmp4_;
#line 144 "../src/PolkitDialog.vala"
				_tmp5_ = ident;
#line 144 "../src/PolkitDialog.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, polkit_unix_user_get_type ())) {
#line 671 "PolkitDialog.c"
					struct passwd* pwd = NULL;
					PolkitIdentity* _tmp6_;
					struct passwd* _tmp7_;
					struct passwd* _tmp8_;
#line 145 "../src/PolkitDialog.vala"
					_tmp6_ = ident;
#line 145 "../src/PolkitDialog.vala"
					_tmp7_ = getpwuid ((uid_t) polkit_unix_user_get_uid (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, polkit_unix_user_get_type (), PolkitUnixUser)));
#line 145 "../src/PolkitDialog.vala"
					pwd = _tmp7_;
#line 146 "../src/PolkitDialog.vala"
					_tmp8_ = pwd;
#line 146 "../src/PolkitDialog.vala"
					if (_tmp8_ != NULL) {
#line 686 "PolkitDialog.c"
						gchar* pw_name = NULL;
						struct passwd* _tmp9_;
						const gchar* _tmp10_;
						gchar* _tmp11_;
						gboolean _tmp12_ = FALSE;
						const gchar* _tmp13_;
						const gchar* _tmp16_;
						gchar* _tmp17_;
#line 147 "../src/PolkitDialog.vala"
						_tmp9_ = pwd;
#line 147 "../src/PolkitDialog.vala"
						_tmp10_ = _tmp9_->pw_name;
#line 147 "../src/PolkitDialog.vala"
						_tmp11_ = g_strdup (_tmp10_);
#line 147 "../src/PolkitDialog.vala"
						pw_name = _tmp11_;
#line 148 "../src/PolkitDialog.vala"
						_tmp13_ = target_user;
#line 148 "../src/PolkitDialog.vala"
						if (_tmp13_ == NULL) {
#line 148 "../src/PolkitDialog.vala"
							_tmp12_ = length < 2;
#line 709 "PolkitDialog.c"
						} else {
#line 148 "../src/PolkitDialog.vala"
							_tmp12_ = FALSE;
#line 713 "PolkitDialog.c"
						}
#line 148 "../src/PolkitDialog.vala"
						if (_tmp12_) {
#line 717 "PolkitDialog.c"
							const gchar* _tmp14_;
							gchar* _tmp15_;
#line 149 "../src/PolkitDialog.vala"
							_tmp14_ = pw_name;
#line 149 "../src/PolkitDialog.vala"
							_tmp15_ = g_strdup (_tmp14_);
#line 149 "../src/PolkitDialog.vala"
							_g_free0 (target_user);
#line 149 "../src/PolkitDialog.vala"
							target_user = _tmp15_;
#line 728 "PolkitDialog.c"
						}
#line 152 "../src/PolkitDialog.vala"
						_tmp16_ = pw_name;
#line 152 "../src/PolkitDialog.vala"
						_tmp17_ = g_strdup (_tmp16_);
#line 152 "../src/PolkitDialog.vala"
						_g_free0 (name);
#line 152 "../src/PolkitDialog.vala"
						name = _tmp17_;
#line 146 "../src/PolkitDialog.vala"
						_g_free0 (pw_name);
#line 740 "PolkitDialog.c"
					}
				} else {
					PolkitIdentity* _tmp18_;
#line 154 "../src/PolkitDialog.vala"
					_tmp18_ = ident;
#line 154 "../src/PolkitDialog.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp18_, polkit_unix_group_get_type ())) {
#line 748 "PolkitDialog.c"
						struct group* gwd = NULL;
						PolkitIdentity* _tmp19_;
						struct group* _tmp20_;
						struct group* _tmp21_;
#line 155 "../src/PolkitDialog.vala"
						_tmp19_ = ident;
#line 155 "../src/PolkitDialog.vala"
						_tmp20_ = getgrgid ((gid_t) polkit_unix_group_get_gid (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, polkit_unix_group_get_type (), PolkitUnixGroup)));
#line 155 "../src/PolkitDialog.vala"
						gwd = _tmp20_;
#line 156 "../src/PolkitDialog.vala"
						_tmp21_ = gwd;
#line 156 "../src/PolkitDialog.vala"
						if (_tmp21_ != NULL) {
#line 763 "PolkitDialog.c"
							struct group* _tmp22_;
							const gchar* _tmp23_;
							gchar* _tmp24_;
#line 157 "../src/PolkitDialog.vala"
							_tmp22_ = gwd;
#line 157 "../src/PolkitDialog.vala"
							_tmp23_ = _tmp22_->gr_name;
#line 157 "../src/PolkitDialog.vala"
							_tmp24_ = g_strdup_printf (_ ("Group: %s"), _tmp23_);
#line 157 "../src/PolkitDialog.vala"
							_g_free0 (name);
#line 157 "../src/PolkitDialog.vala"
							name = _tmp24_;
#line 777 "PolkitDialog.c"
						}
					}
				}
#line 161 "../src/PolkitDialog.vala"
				_tmp25_ = model;
#line 161 "../src/PolkitDialog.vala"
				gtk_list_store_append (_tmp25_, &_tmp26_);
#line 161 "../src/PolkitDialog.vala"
				iter = _tmp26_;
#line 162 "../src/PolkitDialog.vala"
				_tmp27_ = model;
#line 162 "../src/PolkitDialog.vala"
				_tmp28_ = iter;
#line 162 "../src/PolkitDialog.vala"
				_tmp29_ = name;
#line 162 "../src/PolkitDialog.vala"
				_tmp30_ = ident;
#line 162 "../src/PolkitDialog.vala"
				gtk_list_store_set (_tmp27_, &_tmp28_, 0, "avatar-default-symbolic", 1, _tmp29_, 2, _tmp30_, -1);
#line 164 "../src/PolkitDialog.vala"
				_tmp31_ = name;
#line 164 "../src/PolkitDialog.vala"
				_tmp32_ = g_get_user_name ();
#line 164 "../src/PolkitDialog.vala"
				if (g_strcmp0 (_tmp31_, _tmp32_) == 0) {
#line 165 "../src/PolkitDialog.vala"
					active = length;
#line 805 "PolkitDialog.c"
				}
#line 168 "../src/PolkitDialog.vala"
				_tmp33_ = length;
#line 168 "../src/PolkitDialog.vala"
				length = _tmp33_ + 1;
#line 137 "../src/PolkitDialog.vala"
				_g_free0 (name);
#line 813 "PolkitDialog.c"
			}
		}
	}
#line 171 "../src/PolkitDialog.vala"
	_tmp34_ = self->priv->idents_combo;
#line 171 "../src/PolkitDialog.vala"
	_tmp35_ = model;
#line 171 "../src/PolkitDialog.vala"
	gtk_combo_box_set_model (_tmp34_, (GtkTreeModel*) _tmp35_);
#line 172 "../src/PolkitDialog.vala"
	_tmp36_ = self->priv->idents_combo;
#line 172 "../src/PolkitDialog.vala"
	gtk_combo_box_set_active (_tmp36_, active);
#line 174 "../src/PolkitDialog.vala"
	if (length < 2) {
#line 829 "PolkitDialog.c"
		const gchar* _tmp37_;
		const gchar* _tmp38_;
#line 175 "../src/PolkitDialog.vala"
		_tmp37_ = target_user;
#line 175 "../src/PolkitDialog.vala"
		_tmp38_ = g_get_user_name ();
#line 175 "../src/PolkitDialog.vala"
		if (g_strcmp0 (_tmp37_, _tmp38_) == 0) {
#line 838 "PolkitDialog.c"
			GtkComboBox* _tmp39_;
#line 176 "../src/PolkitDialog.vala"
			_tmp39_ = self->priv->idents_combo;
#line 176 "../src/PolkitDialog.vala"
			gtk_widget_set_visible ((GtkWidget*) _tmp39_, FALSE);
#line 844 "PolkitDialog.c"
		} else {
			GtkComboBox* _tmp40_;
#line 178 "../src/PolkitDialog.vala"
			_tmp40_ = self->priv->idents_combo;
#line 178 "../src/PolkitDialog.vala"
			gtk_widget_set_sensitive ((GtkWidget*) _tmp40_, FALSE);
#line 851 "PolkitDialog.c"
		}
	}
#line 128 "../src/PolkitDialog.vala"
	_g_free0 (target_user);
#line 128 "../src/PolkitDialog.vala"
	_g_object_unref0 (model);
#line 858 "PolkitDialog.c"
}

static void
_ag_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error (PolkitAgentSession* _sender,
                                                                    const gchar* text,
                                                                    gpointer self)
{
#line 189 "../src/PolkitDialog.vala"
	ag_polkit_dialog_on_pk_show_error ((AgPolkitDialog*) self, text);
#line 868 "PolkitDialog.c"
}

static void
_ag_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed (PolkitAgentSession* _sender,
                                                                          gboolean gained_authorization,
                                                                          gpointer self)
{
#line 190 "../src/PolkitDialog.vala"
	ag_polkit_dialog_on_pk_session_completed ((AgPolkitDialog*) self, gained_authorization);
#line 878 "PolkitDialog.c"
}

static void
_ag_polkit_dialog_on_pk_request_polkit_agent_session_request (PolkitAgentSession* _sender,
                                                              const gchar* request,
                                                              gboolean echo_on,
                                                              gpointer self)
{
#line 191 "../src/PolkitDialog.vala"
	ag_polkit_dialog_on_pk_request ((AgPolkitDialog*) self, request, echo_on);
#line 889 "PolkitDialog.c"
}

static void
_ag_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info (PolkitAgentSession* _sender,
                                                                  const gchar* text,
                                                                  gpointer self)
{
#line 192 "../src/PolkitDialog.vala"
	ag_polkit_dialog_on_pk_show_info ((AgPolkitDialog*) self, text);
#line 899 "PolkitDialog.c"
}

static void
ag_polkit_dialog_select_session (AgPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	PolkitIdentity* _tmp1_;
	const gchar* _tmp2_;
	PolkitAgentSession* _tmp3_;
	PolkitAgentSession* _tmp4_;
	gulong _tmp5_;
	PolkitAgentSession* _tmp6_;
	gulong _tmp7_;
	PolkitAgentSession* _tmp8_;
	gulong _tmp9_;
	PolkitAgentSession* _tmp10_;
	gulong _tmp11_;
	PolkitAgentSession* _tmp12_;
#line 183 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 184 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 184 "../src/PolkitDialog.vala"
	if (_tmp0_ != NULL) {
#line 185 "../src/PolkitDialog.vala"
		ag_polkit_dialog_deselect_session (self);
#line 926 "PolkitDialog.c"
	}
#line 188 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->pk_identity;
#line 188 "../src/PolkitDialog.vala"
	_tmp2_ = self->priv->cookie;
#line 188 "../src/PolkitDialog.vala"
	_tmp3_ = polkit_agent_session_new (_tmp1_, _tmp2_);
#line 188 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_session);
#line 188 "../src/PolkitDialog.vala"
	self->priv->pk_session = _tmp3_;
#line 189 "../src/PolkitDialog.vala"
	_tmp4_ = self->priv->pk_session;
#line 189 "../src/PolkitDialog.vala"
	_tmp5_ = g_signal_connect_object (_tmp4_, "show-error", (GCallback) _ag_polkit_dialog_on_pk_show_error_polkit_agent_session_show_error, self, 0);
#line 189 "../src/PolkitDialog.vala"
	self->priv->error_signal_id = _tmp5_;
#line 190 "../src/PolkitDialog.vala"
	_tmp6_ = self->priv->pk_session;
#line 190 "../src/PolkitDialog.vala"
	_tmp7_ = g_signal_connect_object (_tmp6_, "completed", (GCallback) _ag_polkit_dialog_on_pk_session_completed_polkit_agent_session_completed, self, 0);
#line 190 "../src/PolkitDialog.vala"
	self->priv->complete_signal_id = _tmp7_;
#line 191 "../src/PolkitDialog.vala"
	_tmp8_ = self->priv->pk_session;
#line 191 "../src/PolkitDialog.vala"
	_tmp9_ = g_signal_connect_object (_tmp8_, "request", (GCallback) _ag_polkit_dialog_on_pk_request_polkit_agent_session_request, self, 0);
#line 191 "../src/PolkitDialog.vala"
	self->priv->request_signal_id = _tmp9_;
#line 192 "../src/PolkitDialog.vala"
	_tmp10_ = self->priv->pk_session;
#line 192 "../src/PolkitDialog.vala"
	_tmp11_ = g_signal_connect_object (_tmp10_, "show-info", (GCallback) _ag_polkit_dialog_on_pk_show_info_polkit_agent_session_show_info, self, 0);
#line 192 "../src/PolkitDialog.vala"
	self->priv->info_signal_id = _tmp11_;
#line 193 "../src/PolkitDialog.vala"
	_tmp12_ = self->priv->pk_session;
#line 193 "../src/PolkitDialog.vala"
	polkit_agent_session_initiate (_tmp12_);
#line 966 "PolkitDialog.c"
}

static void
ag_polkit_dialog_deselect_session (AgPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
#line 196 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 197 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 197 "../src/PolkitDialog.vala"
	if (_tmp0_ != NULL) {
#line 979 "PolkitDialog.c"
		PolkitAgentSession* _tmp1_;
		PolkitAgentSession* _tmp2_;
		PolkitAgentSession* _tmp3_;
		PolkitAgentSession* _tmp4_;
#line 198 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->pk_session;
#line 198 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp1_, self->priv->error_signal_id);
#line 199 "../src/PolkitDialog.vala"
		_tmp2_ = self->priv->pk_session;
#line 199 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp2_, self->priv->complete_signal_id);
#line 200 "../src/PolkitDialog.vala"
		_tmp3_ = self->priv->pk_session;
#line 200 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp3_, self->priv->request_signal_id);
#line 201 "../src/PolkitDialog.vala"
		_tmp4_ = self->priv->pk_session;
#line 201 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect (_tmp4_, self->priv->info_signal_id);
#line 202 "../src/PolkitDialog.vala"
		_g_object_unref0 (self->priv->pk_session);
#line 202 "../src/PolkitDialog.vala"
		self->priv->pk_session = NULL;
#line 1004 "PolkitDialog.c"
	}
}

static void
ag_polkit_dialog_authenticate (AgPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
	GtkEntry* _tmp1_;
	GtkRevealer* _tmp2_;
	PolkitAgentSession* _tmp3_;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
#line 206 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 207 "../src/PolkitDialog.vala"
	if (_tmp0_ == NULL) {
#line 208 "../src/PolkitDialog.vala"
		ag_polkit_dialog_select_session (self);
#line 1025 "PolkitDialog.c"
	}
#line 211 "../src/PolkitDialog.vala"
	_tmp1_ = self->priv->password_entry;
#line 211 "../src/PolkitDialog.vala"
	g_object_set (_tmp1_, "secondary-icon-name", "", NULL);
#line 212 "../src/PolkitDialog.vala"
	_tmp2_ = self->priv->feedback_revealer;
#line 212 "../src/PolkitDialog.vala"
	gtk_revealer_set_reveal_child (_tmp2_, FALSE);
#line 214 "../src/PolkitDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, FALSE);
#line 215 "../src/PolkitDialog.vala"
	_tmp3_ = self->priv->pk_session;
#line 215 "../src/PolkitDialog.vala"
	_tmp4_ = self->priv->password_entry;
#line 215 "../src/PolkitDialog.vala"
	_tmp5_ = gtk_editable_get_text ((GtkEditable*) _tmp4_);
#line 215 "../src/PolkitDialog.vala"
	polkit_agent_session_response (_tmp3_, _tmp5_);
#line 1045 "PolkitDialog.c"
}

static void
ag_polkit_dialog_cancel (AgPolkitDialog* self)
{
	PolkitAgentSession* _tmp0_;
#line 218 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/PolkitDialog.vala"
	self->priv->canceling = TRUE;
#line 220 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->pk_session;
#line 220 "../src/PolkitDialog.vala"
	if (_tmp0_ != NULL) {
#line 1060 "PolkitDialog.c"
		PolkitAgentSession* _tmp1_;
#line 221 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->pk_session;
#line 221 "../src/PolkitDialog.vala"
		polkit_agent_session_cancel (_tmp1_);
#line 1066 "PolkitDialog.c"
	}
#line 224 "../src/PolkitDialog.vala"
	g_debug ("PolkitDialog.vala:224: Authentication cancelled");
#line 225 "../src/PolkitDialog.vala"
	self->was_canceled = TRUE;
#line 227 "../src/PolkitDialog.vala"
	self->priv->canceling = FALSE;
#line 228 "../src/PolkitDialog.vala"
	g_signal_emit (self, ag_polkit_dialog_signals[AG_POLKIT_DIALOG_DONE_SIGNAL], 0);
#line 1076 "PolkitDialog.c"
}

static void
ag_polkit_dialog_on_ident_changed (AgPolkitDialog* self)
{
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	GtkTreeModel* model = NULL;
	GtkComboBox* _tmp3_;
	GtkTreeModel* _tmp4_;
	GtkTreeModel* _tmp5_;
	GtkTreeModel* _tmp6_;
	GtkTreeModel* _tmp7_;
	GtkTreeIter _tmp8_;
	PolkitIdentity* _tmp9_ = NULL;
#line 231 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 234 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->idents_combo;
#line 234 "../src/PolkitDialog.vala"
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
#line 234 "../src/PolkitDialog.vala"
	iter = _tmp1_;
#line 234 "../src/PolkitDialog.vala"
	if (!_tmp2_) {
#line 235 "../src/PolkitDialog.vala"
		ag_polkit_dialog_deselect_session (self);
#line 236 "../src/PolkitDialog.vala"
		return;
#line 1108 "PolkitDialog.c"
	}
#line 239 "../src/PolkitDialog.vala"
	_tmp3_ = self->priv->idents_combo;
#line 239 "../src/PolkitDialog.vala"
	_tmp4_ = gtk_combo_box_get_model (_tmp3_);
#line 239 "../src/PolkitDialog.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 239 "../src/PolkitDialog.vala"
	model = _tmp5_;
#line 240 "../src/PolkitDialog.vala"
	_tmp6_ = model;
#line 240 "../src/PolkitDialog.vala"
	if (_tmp6_ == NULL) {
#line 241 "../src/PolkitDialog.vala"
		_g_object_unref0 (model);
#line 241 "../src/PolkitDialog.vala"
		return;
#line 1126 "PolkitDialog.c"
	}
#line 244 "../src/PolkitDialog.vala"
	_tmp7_ = model;
#line 244 "../src/PolkitDialog.vala"
	_tmp8_ = iter;
#line 244 "../src/PolkitDialog.vala"
	gtk_tree_model_get (_tmp7_, &_tmp8_, 2, &_tmp9_, -1, -1);
#line 244 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_identity);
#line 244 "../src/PolkitDialog.vala"
	self->priv->pk_identity = _tmp9_;
#line 245 "../src/PolkitDialog.vala"
	ag_polkit_dialog_select_session (self);
#line 231 "../src/PolkitDialog.vala"
	_g_object_unref0 (model);
#line 1142 "PolkitDialog.c"
}

static void
ag_polkit_dialog_on_pk_session_completed (AgPolkitDialog* self,
                                          gboolean authorized)
{
	gboolean _tmp0_ = FALSE;
#line 248 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 249 "../src/PolkitDialog.vala"
	if (!authorized) {
#line 249 "../src/PolkitDialog.vala"
		_tmp0_ = TRUE;
#line 1156 "PolkitDialog.c"
	} else {
		GCancellable* _tmp1_;
#line 249 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->cancellable;
#line 249 "../src/PolkitDialog.vala"
		_tmp0_ = g_cancellable_is_cancelled (_tmp1_);
#line 1163 "PolkitDialog.c"
	}
#line 249 "../src/PolkitDialog.vala"
	if (_tmp0_) {
#line 1167 "PolkitDialog.c"
		GtkEntry* _tmp2_;
		GtkEntry* _tmp3_;
#line 250 "../src/PolkitDialog.vala"
		if (!self->priv->canceling) {
#line 251 "../src/PolkitDialog.vala"
			ag_polkit_dialog_on_pk_show_error (self, _ ("Authentication failed. Please try again."));
#line 1174 "PolkitDialog.c"
		}
#line 254 "../src/PolkitDialog.vala"
		ag_polkit_dialog_deselect_session (self);
#line 255 "../src/PolkitDialog.vala"
		_tmp2_ = self->priv->password_entry;
#line 255 "../src/PolkitDialog.vala"
		gtk_editable_set_text ((GtkEditable*) _tmp2_, "");
#line 256 "../src/PolkitDialog.vala"
		_tmp3_ = self->priv->password_entry;
#line 256 "../src/PolkitDialog.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp3_);
#line 257 "../src/PolkitDialog.vala"
		ag_polkit_dialog_select_session (self);
#line 258 "../src/PolkitDialog.vala"
		return;
#line 1190 "PolkitDialog.c"
	} else {
#line 260 "../src/PolkitDialog.vala"
		g_signal_emit (self, ag_polkit_dialog_signals[AG_POLKIT_DIALOG_DONE_SIGNAL], 0);
#line 1194 "PolkitDialog.c"
	}
#line 262 "../src/PolkitDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) self, TRUE);
#line 1198 "PolkitDialog.c"
}

static void
ag_polkit_dialog_on_pk_request (AgPolkitDialog* self,
                                const gchar* request,
                                gboolean echo_on)
{
	GtkEntry* _tmp0_;
#line 265 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 265 "../src/PolkitDialog.vala"
	g_return_if_fail (request != NULL);
#line 266 "../src/PolkitDialog.vala"
	_tmp0_ = self->priv->password_entry;
#line 266 "../src/PolkitDialog.vala"
	gtk_entry_set_visibility (_tmp0_, echo_on);
#line 267 "../src/PolkitDialog.vala"
	if (!g_str_has_prefix (request, "Password:")) {
#line 1217 "PolkitDialog.c"
		GtkLabel* _tmp1_;
#line 268 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->password_label;
#line 268 "../src/PolkitDialog.vala"
		gtk_label_set_label (_tmp1_, request);
#line 1223 "PolkitDialog.c"
	}
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 272 "../src/PolkitDialog.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 272 "../src/PolkitDialog.vala"
	return _data3_;
#line 1234 "PolkitDialog.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 272 "../src/PolkitDialog.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1244 "PolkitDialog.c"
		AgPolkitDialog* self;
#line 272 "../src/PolkitDialog.vala"
		self = _data3_->self;
#line 272 "../src/PolkitDialog.vala"
		_g_object_unref0 (_data3_->shake);
#line 272 "../src/PolkitDialog.vala"
		_g_free0 (_data3_->text);
#line 272 "../src/PolkitDialog.vala"
		_g_object_unref0 (self);
#line 272 "../src/PolkitDialog.vala"
		g_slice_free (Block3Data, _data3_);
#line 1256 "PolkitDialog.c"
	}
}

static void
__lambda5_ (Block3Data* _data3_,
            gdouble val)
{
	AgPolkitDialog* self;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GskTransform* _tmp2_;
	graphene_point_t _tmp3_ = {0};
	GskTransform* _tmp4_;
#line 278 "../src/PolkitDialog.vala"
	self = _data3_->self;
#line 279 "../src/PolkitDialog.vala"
	_tmp0_ = gtk_window_get_child ((GtkWindow*) self);
#line 279 "../src/PolkitDialog.vala"
	_tmp1_ = _tmp0_;
#line 279 "../src/PolkitDialog.vala"
	_tmp2_ = gsk_transform_new ();
#line 279 "../src/PolkitDialog.vala"
	memset (&_tmp3_, 0, sizeof (graphene_point_t));
#line 279 "../src/PolkitDialog.vala"
	_tmp3_.x = (gfloat) ((gint) val);
#line 279 "../src/PolkitDialog.vala"
	_tmp4_ = gsk_transform_translate (_tmp2_, &_tmp3_);
#line 279 "../src/PolkitDialog.vala"
	gtk_widget_allocate (_tmp1_, _data3_->width, _data3_->height, -1, _tmp4_);
#line 1286 "PolkitDialog.c"
}

static void
___lambda5__adw_animation_target_func (gdouble value,
                                       gpointer self)
{
#line 276 "../src/PolkitDialog.vala"
	__lambda5_ (self, value);
#line 1295 "PolkitDialog.c"
}

static void
__lambda6_ (Block3Data* _data3_)
{
	AgPolkitDialog* self;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gint _tmp5_;
#line 292 "../src/PolkitDialog.vala"
	self = _data3_->self;
#line 293 "../src/PolkitDialog.vala"
	if (_data3_->repeat_count == 4) {
#line 1309 "PolkitDialog.c"
		GtkRevealer* _tmp0_;
		GtkEntry* _tmp1_;
		GtkLabel* _tmp2_;
#line 294 "../src/PolkitDialog.vala"
		_tmp0_ = self->priv->feedback_revealer;
#line 294 "../src/PolkitDialog.vala"
		gtk_revealer_set_reveal_child (_tmp0_, TRUE);
#line 295 "../src/PolkitDialog.vala"
		_tmp1_ = self->priv->password_entry;
#line 295 "../src/PolkitDialog.vala"
		g_object_set (_tmp1_, "secondary-icon-name", "dialog-error-symbolic", NULL);
#line 296 "../src/PolkitDialog.vala"
		_tmp2_ = self->priv->password_feedback;
#line 296 "../src/PolkitDialog.vala"
		gtk_label_set_label (_tmp2_, _data3_->text);
#line 297 "../src/PolkitDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) self, TRUE);
#line 298 "../src/PolkitDialog.vala"
		g_signal_handler_disconnect ((GObject*) self, _data3_->iterate);
#line 299 "../src/PolkitDialog.vala"
		return;
#line 1331 "PolkitDialog.c"
	}
#line 302 "../src/PolkitDialog.vala"
	_tmp3_ = adw_timed_animation_get_value_to (_data3_->shake);
#line 302 "../src/PolkitDialog.vala"
	_tmp4_ = _tmp3_;
#line 302 "../src/PolkitDialog.vala"
	adw_timed_animation_set_value_to (_data3_->shake, -1 * _tmp4_);
#line 303 "../src/PolkitDialog.vala"
	adw_animation_play ((AdwAnimation*) _data3_->shake);
#line 304 "../src/PolkitDialog.vala"
	_tmp5_ = _data3_->repeat_count;
#line 304 "../src/PolkitDialog.vala"
	_data3_->repeat_count = _tmp5_ + 1;
#line 1345 "PolkitDialog.c"
}

static void
___lambda6__adw_animation_done (AdwAnimation* _sender,
                                gpointer self)
{
#line 292 "../src/PolkitDialog.vala"
	__lambda6_ (self);
#line 1354 "PolkitDialog.c"
}

static void
ag_polkit_dialog_on_pk_show_error (AgPolkitDialog* self,
                                   const gchar* text)
{
	Block3Data* _data3_;
	gchar* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	AdwCallbackAnimationTarget* _tmp3_;
	AdwTimedAnimation* _tmp4_ = NULL;
	gulong _tmp5_;
#line 272 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 272 "../src/PolkitDialog.vala"
	g_return_if_fail (text != NULL);
#line 272 "../src/PolkitDialog.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 272 "../src/PolkitDialog.vala"
	_data3_->_ref_count_ = 1;
#line 272 "../src/PolkitDialog.vala"
	_data3_->self = g_object_ref (self);
#line 272 "../src/PolkitDialog.vala"
	_tmp0_ = g_strdup (text);
#line 272 "../src/PolkitDialog.vala"
	_g_free0 (_data3_->text);
#line 272 "../src/PolkitDialog.vala"
	_data3_->text = _tmp0_;
#line 273 "../src/PolkitDialog.vala"
	_data3_->width = gtk_widget_get_width ((GtkWidget*) self);
#line 274 "../src/PolkitDialog.vala"
	_data3_->height = gtk_widget_get_height ((GtkWidget*) self);
#line 276 "../src/PolkitDialog.vala"
	_tmp1_ = gtk_window_get_child ((GtkWindow*) self);
#line 276 "../src/PolkitDialog.vala"
	_tmp2_ = _tmp1_;
#line 276 "../src/PolkitDialog.vala"
	_tmp3_ = (AdwCallbackAnimationTarget*) adw_callback_animation_target_new (___lambda5__adw_animation_target_func, block3_data_ref (_data3_), block3_data_unref);
#line 276 "../src/PolkitDialog.vala"
	_tmp4_ = (AdwTimedAnimation*) adw_timed_animation_new (_tmp2_, (gdouble) 0, (gdouble) -24, (guint) 70, (AdwAnimationTarget*) _tmp3_);
#line 276 "../src/PolkitDialog.vala"
	adw_timed_animation_set_easing (_tmp4_, ADW_EASE_OUT_CIRC);
#line 276 "../src/PolkitDialog.vala"
	adw_timed_animation_set_reverse (_tmp4_, TRUE);
#line 276 "../src/PolkitDialog.vala"
	_data3_->shake = _tmp4_;
#line 288 "../src/PolkitDialog.vala"
	adw_animation_play ((AdwAnimation*) _data3_->shake);
#line 290 "../src/PolkitDialog.vala"
	_data3_->repeat_count = 0;
#line 291 "../src/PolkitDialog.vala"
	_data3_->iterate = (gulong) 0;
#line 292 "../src/PolkitDialog.vala"
	_tmp5_ = g_signal_connect_data ((AdwAnimation*) _data3_->shake, "done", (GCallback) ___lambda6__adw_animation_done, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 292 "../src/PolkitDialog.vala"
	_data3_->iterate = _tmp5_;
#line 272 "../src/PolkitDialog.vala"
	block3_data_unref (_data3_);
#line 272 "../src/PolkitDialog.vala"
	_data3_ = NULL;
#line 1416 "PolkitDialog.c"
}

static void
ag_polkit_dialog_on_pk_show_info (AgPolkitDialog* self,
                                  const gchar* text)
{
#line 308 "../src/PolkitDialog.vala"
	g_return_if_fail (self != NULL);
#line 308 "../src/PolkitDialog.vala"
	g_return_if_fail (text != NULL);
#line 309 "../src/PolkitDialog.vala"
	g_info ("PolkitDialog.vala:309: %s", text);
#line 1429 "PolkitDialog.c"
}

static void
ag_polkit_dialog_class_init (AgPolkitDialogClass * klass,
                             gpointer klass_data)
{
#line 26 "../src/PolkitDialog.vala"
	ag_polkit_dialog_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/PolkitDialog.vala"
	g_type_class_adjust_private_offset (klass, &AgPolkitDialog_private_offset);
#line 26 "../src/PolkitDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = ag_polkit_dialog_finalize;
#line 26 "../src/PolkitDialog.vala"
	ag_polkit_dialog_signals[AG_POLKIT_DIALOG_DONE_SIGNAL] = g_signal_new ("done", AG_TYPE_POLKIT_DIALOG, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1444 "PolkitDialog.c"
}

static void
ag_polkit_dialog_instance_init (AgPolkitDialog * self,
                                gpointer klass)
{
#line 26 "../src/PolkitDialog.vala"
	self->priv = ag_polkit_dialog_get_instance_private (self);
#line 28 "../src/PolkitDialog.vala"
	self->was_canceled = FALSE;
#line 30 "../src/PolkitDialog.vala"
	self->priv->pk_session = NULL;
#line 31 "../src/PolkitDialog.vala"
	self->priv->pk_identity = NULL;
#line 41 "../src/PolkitDialog.vala"
	self->priv->canceling = FALSE;
#line 1461 "PolkitDialog.c"
}

static void
ag_polkit_dialog_finalize (GObject * obj)
{
	AgPolkitDialog * self;
#line 26 "../src/PolkitDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, AG_TYPE_POLKIT_DIALOG, AgPolkitDialog);
#line 30 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_session);
#line 31 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->pk_identity);
#line 40 "../src/PolkitDialog.vala"
	_g_free0 (self->priv->cookie);
#line 43 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->feedback_revealer);
#line 44 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_label);
#line 45 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_feedback);
#line 46 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->password_entry);
#line 47 "../src/PolkitDialog.vala"
	_g_object_unref0 (self->priv->idents_combo);
#line 26 "../src/PolkitDialog.vala"
	G_OBJECT_CLASS (ag_polkit_dialog_parent_class)->finalize (obj);
#line 1488 "PolkitDialog.c"
}

static GType
ag_polkit_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AgPolkitDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) ag_polkit_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AgPolkitDialog), 0, (GInstanceInitFunc) ag_polkit_dialog_instance_init, NULL };
	GType ag_polkit_dialog_type_id;
	ag_polkit_dialog_type_id = g_type_register_static (GRANITE_TYPE_MESSAGE_DIALOG, "AgPolkitDialog", &g_define_type_info, 0);
	AgPolkitDialog_private_offset = g_type_add_instance_private (ag_polkit_dialog_type_id, sizeof (AgPolkitDialogPrivate));
	return ag_polkit_dialog_type_id;
}

GType
ag_polkit_dialog_get_type (void)
{
	static volatile gsize ag_polkit_dialog_type_id__once = 0;
	if (g_once_init_enter (&ag_polkit_dialog_type_id__once)) {
		GType ag_polkit_dialog_type_id;
		ag_polkit_dialog_type_id = ag_polkit_dialog_get_type_once ();
		g_once_init_leave (&ag_polkit_dialog_type_id__once, ag_polkit_dialog_type_id);
	}
	return ag_polkit_dialog_type_id__once;
}

